import gleam/dynamic/decode.{type Decoder}
import models/trade_symbol.{type TradeSymbol}

pub type ExtractionYield {
  ExtractionYield(symbol: TradeSymbol, units: Int)
}

pub fn decoder() -> Decoder(ExtractionYield) {
  use symbol <- decode.field("symbol", trade_symbol.decoder())
  use units <- decode.field("units", decode.int)
  decode.success(ExtractionYield(symbol:, units:))
}
