import gleam/dynamic/decode.{type Decoder}
import models/faction_trait_symbol.{type FactionTraitSymbol}

pub type FactionTrait {
  FactionTrait(symbol: FactionTraitSymbol, name: String, description: String)
}

pub fn decoder() -> Decoder(FactionTrait) {
  use symbol <- decode.field("symbol", faction_trait_symbol.decoder())
  use name <- decode.field("name", decode.string)
  use description <- decode.field("description", decode.string)
  decode.success(FactionTrait(symbol:, name:, description:))
}
