import endpoints/accounts
import endpoints/global
import gleeunit
import utils/env

pub fn main() -> Nil {
  gleeunit.main()
}

pub fn status_test() {
  let assert Ok(_) = global.get_server_status()
}

pub fn error_codes_test() {
  let assert Ok(_) = global.list_error_codes()
}

pub fn account_test() {
  let assert Ok(_) = accounts.get_account(env.load_unsafe().agent_token)
}
